module Ptf
  module Cli
    class Task < Thor

      desc "create", "Create a new task"
      option :title, :type => :string, :required => true, :aliases => :t
      option :group, :type => :string, :aliases => :g
      option :date, :type => :string, :aliases => :d
      option :estimate, :type => :numeric, :aliases => :e
      def create
        puts Ptf::Commands::Task::Create.create(options[:title], options[:group], options[:date], options[:estimate])
      end

      desc "edit ID", "Edit a task"
      def edit(id)
        puts Ptf::Commands::Task::Edit.edit(id.to_i)
      end

      desc "show ID", "Show a task"
      def show(id)
        puts Ptf::Commands::Task.show(id)
      end

      desc "close ID", "Mark a task a completed"
      def close(id)
        puts Ptf::Commands::Task.close(id)
      end

      desc "reopen ID", "Reopen a closed task"
      def reopen(id)
        puts Ptf::Commands::Task.reopen(id)
      end

    end
  end
end

