require 'ptf/commands/task/create'
require 'ptf/commands/task/edit'

module Ptf
  module Commands
    module Task
      class << self

        def show(id)
          if !Ptf::FileSystem.id_exist?(id.to_i)
            return "Task #{id} does not exist."
          end

          metadata_file = Ptf::FileSystem.find_file id.to_i

          if metadata_file.nil?
            return "Task #{id} has been closed. Reopen it with ptf task reopen ###."
          end

          info = Ptf::MetadataFile.create_from_file(metadata_file)

          data_file = File.join(Ptf::FileSystem.data_dir, info.hash)
          return File.read data_file
        end

        def close(id)
          if !Ptf::FileSystem.id_exist?(id.to_i)
            return "Task #{id} does not exist."
          end

          metadata_file = Ptf::FileSystem.find_file id.to_i

          if metadata_file.nil?
            return "Task #{id} has been closed. Reopen it with ptf task reopen ###."
          end

          info = Ptf::MetadataFile.create_from_file(metadata_file)

          info.complete_now
          return "Task #{info.id} is closed."
        end

        def reopen(id)
          if !Ptf::FileSystem.id_exist?(id.to_i)
            return "Task #{id} does not exist."
          end

          metadata_file = Ptf::FileSystem.find_file id.to_i, false

          if metadata_file.nil?
            return "Task #{id} is already open. Close it with ptf task close ###."
          end

          info = Ptf::MetadataFile.create_from_file(metadata_file)

          info.reopen
          return "Task #{info.id} is reopened."
        end

      end
    end
  end
end
