require 'yaml'

module Ptf
  module Config
    YAML_LOCATION = File.join(Dir.home, ".ptfconfig")

    EDITABLE = {
      :default_group => "unassigned:NONE",
      :base_dir => File.join(Dir.home, ".ptf")
    }

    STATIC = {
      :file_permission => 0700,
      :id_counter_start => "1",
      :task_metadata_dir => "info",
      :task_data_dir => "data",
      :in_progress_dir => "open",
      :completed_dir => "closed",
      :tmp_dir => "tmp",
      :task_counter_file => "id_counter",
      :group_list_file => "group_list"
    }

    def self.get_config
      yaml_settings = {}

      yaml_settings = YAML.load(File.read(YAML_LOCATION)) if File.exist?(YAML_LOCATION)

      EDITABLE.merge(yaml_settings).merge(STATIC)
    end

    def self.write_config(config)
      new_config = EDITABLE.merge config.select { |k| EDITABLE.keys.include? k }

      yaml_file = File.new(YAML_LOCATION, "w")
      yaml_file.puts new_config.to_yaml
      yaml_file.close
    end

  end
end

